dsa-check-running-kernel: Try to fix zcat kernel case
[mirror/dsa-nagios.git] / dsa-nagios-checks / checks / dsa-check-running-kernel
1 #!/bin/bash
2
3 # Check if the running kernel has the same version string as the on-disk
4 # kernel image.
5
6 # Copyright 2008,2009,2011 Peter Palfrader
7 # Copyright 2009 Stephen Gran
8 # Copyright 2010,2012,2013 Uli Martens
9 # Copyright 2011 Alexander Reichle-Schmehl
10 #
11 # Permission is hereby granted, free of charge, to any person obtaining
12 # a copy of this software and associated documentation files (the
13 # "Software"), to deal in the Software without restriction, including
14 # without limitation the rights to use, copy, modify, merge, publish,
15 # distribute, sublicense, and/or sell copies of the Software, and to
16 # permit persons to whom the Software is furnished to do so, subject to
17 # the following conditions:
18 #
19 # The above copyright notice and this permission notice shall be
20 # included in all copies or substantial portions of the Software.
21 #
22 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
23 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
24 # MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
25 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
26 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
27 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
28 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
29
30 OK=0;
31 WARNING=1;
32 CRITICAL=2;
33 UNKNOWN=3;
34
35 get_offset() {
36         local file needle
37
38         file="$1"
39         needle="$2"
40         perl -e '
41                 undef $/;
42                 $i = index(<>, "'"$needle"'");
43                 if ($i < 0) {
44                         exit 1;
45                 };
46                 print $i,"\n"' < "$file"
47 }
48
49 get_avail() {
50         # This is wrong, but leaves room for when we have to care for machines running
51         # myfirstunix-image-0.1-dsa-arm
52         local prefix="$1"; shift
53
54         local kervers=$(uname -r)
55
56         local metavers=''
57
58         # DSA uses kernel versions of the form 2.6.29.3-dsa-dl380-oldxeon, where
59         # Debian uses versions of the form 2.6.29-2-amd64
60         if [ "${kervers#3}" != "$kervers" ]; then
61                 metavers=$(echo $kervers | sed -r -e 's/^3\.[0-9].[0-9]+-[A-Za-z0-9\.]+-(.*)/\1/')
62         elif [ "${kervers//dsa}" != "$kervers" ]; then
63                 metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+([\.0-9]+?)-(.*)/2.\1-\3/')
64         else
65                 metavers=$(echo $kervers | sed -r -e 's/^2\.(4|6)\.[0-9]+-[A-Za-z0-9\.]+-(.*)/2.\1-\2/')
66         fi
67
68         # Attempt to track back to a metapackage failed.  bail
69         if [ "$metavers" = "$kervers" ]; then
70                 return 2
71         fi
72
73         # We're just going to give up if we can't find a matching metapackage
74         # I tried being strict once, and it just caused a lot of headaches.  We'll see how
75         # being lax does for us
76
77         local output=$(apt-cache policy ${prefix}-image-${metavers} 2>/dev/null)
78         local metaavailvers=$(echo "$output" | grep '^  Candidate:' | awk '{print $2}')
79         local metainstavers=$(echo "$output" | grep '^  Installed:' | awk '{print $2}')
80
81         if [ -z "$metaavailvers" ] || [ "$metaavailvers" = '(none)' ]; then
82                 return 2
83         fi
84         if [ -z "$metainstavers" ] || [ "$metainstavers" = '(none)' ]; then
85                 return 2
86         fi
87
88         if [ "$metaavailvers" != "$metainstavers" ] ; then
89                 echo "${prefix}-image-${metavers} $metaavailvers available but $metainstavers installed"
90                 return 1
91         fi
92
93         local imagename=0
94         # --no-all-versions show shows only the candidate
95         for vers in $(apt-cache --no-all-versions show ${prefix}-image-${metavers} | sed -n 's/^Depends: //p' | tr ',' '\n' | tr -d ' ' | grep ${prefix}-image | awk '{print $1}' | sort -u); do
96                 if dpkg --compare-versions "1.$vers" gt "1.$imagename"; then
97                         imagename=$vers
98                 fi
99         done
100
101         if [ -z "$imagename" ] || [ "$imagename" = 0 ]; then
102                 return 2
103         fi
104
105         if [ "$imagename" != "${prefix}-image-${kervers}" ]; then
106                 if dpkg --compare-versions 1."$imagename" lt 1."${prefix}-image-${kervers}"; then
107                         return 2
108                 fi
109                 echo "$imagename" != "${prefix}-image-${kervers}"
110                 return 1
111         fi
112
113         local availvrs=$(apt-cache policy ${imagename} 2>/dev/null | grep '^  Candidate' | awk '{print $2}')
114         local kernelversion=$(apt-cache policy ${prefix}-image-${kervers} 2>/dev/null | grep '^  Installed:' | awk '{print $2}')
115
116         if [ "$availvrs" = "$kernelversion" ]; then
117                 return 0
118         fi
119
120         echo "$kernelversion != $availvrs"
121         return 1
122 }
123
124 cat_vmlinux() {
125         local image header filter hdroff
126
127         image="$1"
128         header="$2"
129         filter="$3"
130         hdroff="$4"
131
132         off=`get_offset "$image" $header`
133         local ret="$?"
134         if [ "$ret" != 0 ]; then
135                 # not found, exit
136                 return 1
137         fi
138
139         (if [ "$off" != 0 ]; then
140            dd ibs="$((off+hdroff))" skip=1 count=0
141          fi &&
142          dd bs=512k) < "$image"  2>/dev/null | $filter 2>/dev/null
143         return 0
144 }
145
146 get_image_linux() {
147         local image
148
149         image="$1"
150
151         # gzip compressed image
152         if cat_vmlinux "$image" "\x1f\x8b\x08\x00"      "zcat"   0; then return; fi
153         if cat_vmlinux "$image" "\x1f\x8b\x08\x08"      "zcat"   0; then return; fi
154         # lzma compressed image
155         if cat_vmlinux "$image" "\x00\x00\x00\x02\xff"  "xzcat" -1; then return; fi
156         if cat_vmlinux "$image" "\x00\x00\x00\x04\xff"  "xzcat" -1; then return; fi
157         # xz compressed image
158         if cat_vmlinux "$image" "\xfd\x37\x7a\x58\x5a " "xzcat"  0; then return; fi
159
160         echo "ERROR: Unable to extract kernel image." 2>&1
161         exit 1
162 }
163
164
165 freebsd_check_running_version() {
166         local imagefile="$1"; shift
167
168         local r="$(uname -r)"
169         local v="$(uname -v| sed -e 's/^#[0-9]*/&:/')"
170
171         local q='@\(#\)FreeBSD '"$r $v"
172
173         if zcat "$imagefile" | $STRINGS | egrep -q "$q"; then
174                 echo "OK"
175         else
176                 echo "not OK"
177         fi
178 }
179
180 STRINGS="";
181 if [ -x "$(which strings)" ]; then
182         STRINGS="$(which strings)"
183 elif [ -x "$(which busybox)" -a "$( echo foobar | $(which busybox) strings 2>/dev/null)" = "foobar" ]; then
184         STRINGS="$(which busybox) strings"
185 fi
186
187 searched=""
188 for on_disk in \
189         "/boot/vmlinuz-`uname -r`"\
190         "/boot/vmlinux-`uname -r`"\
191         "/boot/kfreebsd-`uname -r`.gz"; do
192
193         if [ -e "$on_disk" ]; then
194                 if [ -z "$STRINGS" ]; then
195                         echo "UNKNOWN: 'strings' command missing, perhaps install binutils or busybox?"
196                         exit $UNKNOWN
197                 fi
198                 if [ "${on_disk/vmlinu}" != "$on_disk" ]; then
199                         on_disk_version="`get_image_linux "$on_disk" | $STRINGS | grep 'Linux version' | head -n1`"
200                         if [ -x /usr/bin/lsb_release ] ; then
201                                 vendor=$(lsb_release -i -s)
202                                 if [ -n "$vendor" ] && [ "xDebian" != "x$vendor" ] ; then
203                                         on_disk_version=$( echo $on_disk_version|sed -e "s/ ($vendor [[:alnum:]\.-]\+ [[:alnum:]\.]\+)//")
204                                 fi
205                         fi
206                         [ -z "$on_disk_version" ] || break
207                         on_disk_version="`cat "$on_disk" | $STRINGS | grep 'Linux version' | head -n1`"
208                         [ -z "$on_disk_version" ] || break
209
210                         echo "UNKNOWN: Failed to get a version string from image $on_disk"
211                         exit $UNKNOWN
212                 else
213                         on_disk_version="$(zcat $on_disk | $STRINGS | grep Debian | head -n 1 | sed -e 's/Debian [[:alnum:]]\+ (\(.*\))/\1/')"
214                 fi
215         fi
216         searched="$searched $on_disk"
217 done
218
219 if ! [ -e "$on_disk" ]; then
220         echo "WARNING: Did not find a kernel image (checked$searched) - I have no idea which kernel I am running"
221         exit $WARNING
222 fi
223
224 if [ "$(uname -s)" = "Linux" ]; then
225         running_version="`cat /proc/version`"
226         if [ -z "$running_version" ] ; then
227                 echo "UNKNOWN: Failed to get a version string from running system"
228                 exit $UNKNOWN
229         fi
230
231         if [ "$running_version" != "$on_disk_version" ]; then
232                 echo "WARNING: Running kernel does not match on-disk kernel image: [$running_version != $on_disk_version]"
233                 exit $WARNING
234         fi
235
236         ret="$(get_avail linux)"
237         if [ $? = 1 ]; then
238                 echo "WARNING: Kernel needs upgrade [$ret]"
239                 exit $WARNING
240         fi
241 else
242         image_current=$(freebsd_check_running_version $on_disk)
243         running_version="`uname -s` `uname -r` `uname -v`"
244         if [ "$image_current" != "OK" ]; then
245                 approx_time="$(date -d "@`stat -c '%Y' "$on_disk"`" +"%Y-%m-%d %H:%M:%S")"
246                 echo "WARNING: Currently running kernel ($running_version) does not match on disk image (~ $approx_time)"
247                 exit $WARNING;
248         fi
249
250         ret="$(get_avail linux)"
251         if [ $? = 1 ]; then
252                 echo "WARNING: Kernel needs upgrade [$ret]"
253                 exit $WARNING
254         fi
255 fi
256
257 echo "OK: Running kernel matches on disk image: [$running_version]"
258 exit $OK